const meses = document.querySelectorAll('.nb-mes>a');
const marca = document.getElementById('cal-marca');
const menuItems = document.querySelectorAll('.lateral-menu .ol-latmen .li-latmen a');
const cal = document.getElementById('calendario');
const secciones = document.querySelectorAll('.nb-section');
const sections = document.querySelectorAll('.cont-section');
const home = document.querySelector('.cont-home');
const navbar = document.getElementById('navbar');
const members = document.querySelectorAll('.flip-card');

const fuente = 16;

const timeout = ms => new Promise(res => setTimeout(res, ms));

document.addEventListener('DOMContentLoaded', () => {
	prepararVolverArriba();
	prepararHeaderMovil();
	if (home)
		prepararHome();
	console.log(menuItems)
	console.log(sections)
	if (menuItems.length && sections.length && menuItems.length == sections.length)
		prepararMenuLateral();
	if (meses.length)
		prepararNotebook();
	if (members && window.innerWidth > window.innerHeight)
		prepararPopUpTeam();
	if (window.innerWidth < window.innerHeight)
		prepararNavbarMovil();
});

// Subsecciones Navbar
function prepararNavbarMovil() {
	const b = document.getElementById('bocata');
	const snv = document.getElementById('enlaces');
	const cerrar = document.getElementById('cerrarMenu');
	b.addEventListener('click', () => {
		snv.style.display = 'block';
		cerrar.style.display = 'block';
	});
	cerrar.addEventListener('click', () => {
		snv.style.display = 'none';
		cerrar.style.display = 'none';
	});
}

// Header
async function prepararHeaderMovil() {
	if (window.innerWidth > window.innerHeight)
		return;
	const header = document.getElementById('header');
	const vel = 20;
	let x = 0;
	while (true) {
		while (x < 100) {
			header.style.backgroundPositionX = x+'%';
			await timeout(vel);
			x += 0.5;
		}
		while (x >= 0) {
			header.style.backgroundPositionX = x+'%';
			await timeout(vel);
			x -= 0.5;
		}
	}
}

// Home
let timeoutMostrarNav;

function prepararHome() {
	const tardanza = 4200;
	navbar.style.position = 'fixed';
	navbar.style.display = 'none';
	navbar.style.opacity = '0';
	if (!window.scrollY) {
		const bajar = setTimeout(() => {
			document.getElementById('pagina').scrollIntoView();
			const jej = document.getElementById('jej');
			jej.style.backgroundImage = "url(https://static.igem.wiki/teams/5466/static/animacinafb1.gif)"
		}, tardanza);
		const quitarTimeout = () => clearTimeout(bajar);
		window.addEventListener('scroll', quitarTimeout);
		setTimeout(() => window.removeEventListener('scroll', quitarTimeout), tardanza)
	}
	escribirTituloAMaquina();
	activarEventosHome();
}

function activarEventosHome() {
	navbar.addEventListener('mouseover', () => clearTimeout(timeoutMostrarNav));
	document.body.addEventListener('mousemove', (e) => {
		if (e.clientY >= window.innerHeight/5)
			return;
		clearTimeout(timeoutMostrarNav);
		navbar.style.display = 'flex';
		setTimeout(() => navbar.style.opacity = '1', 10);
		timeoutMostrarNav = setTimeout(() => {
			navbar.style.opacity = '0';
			setTimeout(() => navbar.style.display = 'none', 400);
		}, 2500);
	});
}

async function escribirTituloAMaquina() {
	const elem = document.getElementById('titulaco');
	const titulo = elem.textContent;
	elem.textContent = "";
	for (const c of titulo) {
		elem.textContent += c;
		await timeout(100);
	}
}

// Menu lateral
function prepararMenuLateral() {
	window.addEventListener('scroll', marcarActualComoActivo);
	marcarActualComoActivo();
}

function marcarActualComoActivo() {
	let index = sections.length;
	while (--index && window.scrollY + 100 < sections[index].offsetTop) {}
	for (const item of menuItems) item.parentNode.classList.remove('active')
	menuItems[index].parentNode.classList.add('active');
}

// Notebook
function prepararNotebook() {
	window.addEventListener('resize', ajustarCalendario);
	window.addEventListener('resize', moverMarca);
	window.addEventListener('scroll', moverMarca);
	ajustarCalendario();
	vigilarMarca();
	moverMarca();
}

function ajustarCalendario() {
	const sec_alt = cal.clientHeight / meses.length;
	let i = 0;
	for (const mes of meses) {
		mes.setAttribute('style', 'top:' + (i*sec_alt+sec_alt/2-fuente/2-2) + 'px;')
		i++;
	}
}

function moverMarca() {
	if (marca.style.cursor == 'grabbing') return;
	const sec_alt = cal.clientHeight/meses.length;
	let i = secciones.length;
	while (--i && window.scrollY + 100 < secciones[i].offsetTop) {}
	marca.style.top = (i*sec_alt+sec_alt/2-fuente/2-2) + "px";
}

function vigilarMarca() {
	let posI = 0, difPos = 0;

	const darClic = (e) => {
		e.preventDefault();
		posI = e.clientY;
		marca.style.cursor = 'grabbing';
		marca.style.transition = 'top 0s';
		document.body.style.cursor = 'grabbing';
		document.onmouseup = soltarClic;
		document.onmousemove = arrastrando;
	}

	const arrastrando = (e) => {
		e.preventDefault();
		const sec_alt = cal.clientHeight/meses.length;
		const lim_sup = sec_alt/2-fuente/2-2;
		const lim_inf = (meses.length-1)*sec_alt+sec_alt/2-fuente/2-2;
		let top = marca.offsetTop;
		let sec = Math.floor(top/sec_alt);
		difPos = posI - e.clientY;
		posI = e.clientY;
		top -= difPos;
		if (top < lim_sup) {
			marca.style.top = lim_sup+'px';
			if (sec) {
				location.assign(meses.item(0).getAttribute("href"));
				sec = 0;
			}
		} else if (top > lim_inf) {
			marca.style.top = lim_inf+'px';
			if (sec != meses.length-1) {
				location.assign(meses.item(meses.length-1).getAttribute("href"));
				sec = meses.length-1;
			}
		} else {
			marca.style.top = top + 'px';
			const sec_act = Math.floor((top+marca.style.height/2)/sec_alt);
			if (sec != sec_act) {
				location.assign(meses.item(sec_act).getAttribute("href"));
				sec = sec_act;
			}
		}
	}

	const soltarClic = () => {
		marca.style.cursor = 'grab';
		marca.style.transition = 'top 0.1s ease-out'
		document.body.style.cursor = '';
		document.onmouseup = null;
		document.onmousemove = null;
		moverMarca();
	}

	marca.onmousedown = darClic;
}

// Pop up
const info = {
	"dani": {
		"nombre": "Daniel Bulnes Roldán",
		"desc": "I consider myself a person passionate about molecular biology, always willing to learn new things. I enjoy good company and going on hikes and cycling. For me, iGEM represents my ambition to take on new challenges and improve towards a research career, as well as a great opportunity to meet new people with similar aspirations and interests."
	},
	"victor": {
		"nombre": "Víctor Cerván Bueno",
		"desc": "I'm a curious person, passionate about all life sciences. In my free time, I enjoy playing the piano and listening to music. As an individual with a strong drive for learning and self-improvement, I am always seeking for new challenges to prove myself and acquire new knowledge. iGEM was an opportunity for me to step out of my comfort zone, learn more about synthetic biology and achieve personal growth."
	},
	"adrian": {
		"nombre": "Adrián Gómez Lara",
		"desc": "I consider myself an eclectic, curious person with diverse interests. I try to see things from different perspectives and don’t like to get stuck on just one thing. I love reading, I spend all day listening to music, and I would like to spend more time with my friends, preferably playing TTRPGs. For me, iGEM and synthetic biology represent an innovative way to seek solutions to a myriad of problems using my field of study, biology, but with a twist, complementing it with an engineering perspective. This vision captivated me and made me want to be part of it."
	},
	"juan-antonio": {
		"nombre": "Juan Antonio De La Cruz Bellido",
		"desc": "I have been passionate about science since childhood, especially about natural sciences such as biology.  Studying it has been my aspiration since that time and my dream is to become a researcher. I am fascinated by vertebrate paleontology from an early age, although I have been completely focused on bioinformatics for a year. The ambition to always improve, the search for opportunities and learn everything I can to be the scientist I always wanted, were the reasons why I wanted to join the iGEM UMA team."
	},
	"lucia-aguilar": {
		"nombre": "Lucía Aguilar Rosso",
		"desc": "I consider myself a curious person, without very defined tastes. One day I might be interested in jazz music and fashion and the next I'm reading an article about how it would be physically possible to travel in time. For me, being surrounded by people who know so much about so many things is what motivated me the most to work on an iGEM project. I knew it would help me to orient my future a little more on a personal and professional level, giving me the opportunity to be in constant learning with numerous challenges."
	},
	"lucia-campos": {
		"nombre": "Lucía Campos Sánchez",
		"desc": "I am a very lively person with a lot of strength, who loves learning new things every day, especially if they are related to life sciences. I am passionate about very different areas ranging from microbiology, animal and plant physiology to those related to biodiversity. In addition, I love languages and dealing with people. In my free time I dedicate my time to going to the gym or reading. Perhaps because of all of the above, I saw iGEM as an opportunity to develop and apply my knowledge thanks to the confluence of ideas that develops when working with people from different fields, thus obtaining a different approach when defining my future career."
	},
	"angel": {
		"nombre": "Ángel Navarro Fernández",
		"desc": "I consider myself a restless and curious person, who uses his free time to connect with nature, but who also loves to take what he sees to the lab. In the academic field, I am passionate about many aspects of Cell Biology and Genetics, but above all, the origin, development, and evolution of life on our planet. I believe that complementing the university experience with extracurricular activities like iGEM is crucial for personal and professional growth. iGEM allows me to channel my curiosity and passion for biology into real-world applications, pushing the boundaries of knowledge and innovation, while working alongside a diverse and driven team."
	},
	"nogal": {
		"nombre": "Nogal Pérez Velasco",
		"desc": "People are my passion! Understanding how that slimy pink mass builds something as complex as the perception of reality for each person simply fascinates me. Apart from the human mind, I like dancing and waterpolo, but if I had to choose something, what I like the most is to eat! :). Joining iGEM means an approach to interdisciplinary research, a feature that I consider fundamental given the confluence of knowledge in certain fields of science, such as neuroscience."
	},
	"jimena": {
		"nombre": "Jimena García Arca",
		"desc": "As a lover of reading and learning, any subject interests me and I am always willing to learn something new, and although biology is not my area of study, I like this world more and more every day. My passion to discover and, above all, to improve myself has been the main reason why I joined iGEM UMA. Working with people who are passionate about synthetic biology and learning from them while showing my knowledge in Translation is a constant source of motivation that has allowed me to enter an unknown but attractive world, and to open my professional horizons."
	},
	"alvaro": {
		"nombre": "Álvaro Acedo Espejo",
		"desc": "I have always loved trying new things. Learning, discovering new interests and meeting new people are major interests to me, so when I heard about IGEM, I thought it was right up my alley! "
	},
	"pablo": {
		"nombre": "Pablo Fernández Serrano",
		"desc": "Working in a non-tech related project was a experience I always wanted to have. So joining IGEM looked like a great opportunity to gain that experience and meet new amazing people."
	},
	"ruben": {
		"nombre": "Rubén Ipiña Rivas",
		"desc": "I have always been a science and technology enthusiast, in fact, as a child I always said I wanted to be an inventor. In the end I ended up opting more for the world of computer science and programming, but I am still interested in other disciplines. I have carried out many programming projects as a hobby, but always alone, until I realized that by joining a great team I could create much more interesting things. That's why I joined iGEM, to contribute my bit to the world of synthetic biology, and I'm very proud to participate in this exciting project."
	},
	"alonso": {
		"nombre": "Alonso Molina Calvo",
		"desc": "A knowledgeable person who is always disposed to tell us objectively every fact in which our team is weak or strong. That was very useful since the start of the project. He may be apparently a cold person, but we are sure that if you listen to his laughter you will laugh too!"
	},
	"paola": {
		"nombre": "Paola Morales González",
		"desc": "She is a reliable person whose presence is always noticeable in the room, partly for her useful contributions to the theme we could have discussed, and also for her great style. She is the most fashionable!"
	},
	"carmen": {
		"nombre": "Carmen Jiménez Amores",
		"desc": "She is a person with a strong character and sense of justice. She was essential at our first steps at the laboratory, as she served us as a guide and reference. One thing that she loves at the laboratory is wearing her fashionable pink gloves."
	},
	"piedad": {
		"nombre": "Piedad Valverde Guillén",
		"desc": "She is a disciplined, sweet person in which we could always have counted if we needed assistance in the process of contacting companies. She may look calm, but the truth is that she is very proactive and is always working on something."
	},
	"patri": {
		"nombre": "Patricia Zarza Herrero",
		"desc": "She is a very charismatic person with incredible social skills. Her ability to connect people was crucial as she guided us in the process of networking. If you ever want to meet someone, ask her for help. We are 90% sure that she will know that person!"
	},
	"antonia": {
		"nombre": "Antonia Belén del Valle Fierro",
		"desc": "As a sunny person, she always gives us good vibes when she is near. Her labor on instructing us in the social media area was decisive to make ourselves known. Also, we learned a lot about Canva and design from her!"
	},
	"carlos": {
		"nombre": "Carlos Francisco Rodríguez Caso",
		"desc": "A curious person that loves making scientific jokes. However, no one usually catches them… He assisted us in the Wet Lab and Dry Lab areas."
	},
	"manuel": {
		"nombre": "Manuel Bernal Muñoz",
		"desc": "An apparently serious individual, but with a great sense of humor. He may appear at any moment to give us important advice in the Wet Lab and Human Practices areas."
	},
}

function prepararPopUpTeam() {
	const popup = document.createElement('div');
	const fondo = document.createElement('div');
	const cont = document.createElement('div');
	const foto = document.createElement('img');
	const cerrar = document.createElement('img');
	const textos = document.createElement('div');
	const nombre = document.createElement('h1');
	const texto = document.createElement('p');
	textos.appendChild(nombre);
	textos.appendChild(texto);
	cont.appendChild(foto);
	cont.appendChild(textos);
	popup.appendChild(fondo);
	popup.appendChild(cont);
	cont.appendChild(cerrar);
	cont.classList.add('popup-cont');
	textos.classList.add('popup-info');
	foto.classList.add('popup-foto');
	fondo.classList.add('popup-fondo');
	popup.classList.add('popup');
	cerrar.classList.add('popup-cerrar');
	fondo.addEventListener('click', () => popup.classList.remove('popup-activo'));
	cerrar.addEventListener('click', () => popup.classList.remove('popup-activo'));
	cerrar.src = "https://static.igem.wiki/teams/5466/static/team/equis.png";
	document.getElementById('pagina').appendChild(popup);
	for (const member of members) {
		member.addEventListener('click', () => {
			popup.classList.add('popup-activo');
			foto.src = "https://static.igem.wiki/teams/5466/static/team/dp-"+member.id+".webp";
			foto.alt = "";
			nombre.textContent = info[member.id]['nombre'];
			texto.textContent = info[member.id]['desc'];
		});
	}
}

// Volver
function prepararVolverArriba() {
	const bot = document.querySelector('.volver-arriba');
	bot.addEventListener('click', () => {
		scrollTo(0,0);
	});
	window.addEventListener('scroll', () => {
		if (window.scrollY) {
			bot.classList.remove('volver-oculto');
		} else {
			bot.classList.add('volver-oculto');
		}
	});
}
